#if !defined ( BZIP_HPP )
#define BZIP_HPP

#include <wx/progdlg.h>
#include "dfilesystem.hpp"
#include "dfile.hpp"

class Bzip : public DFile
{
public:
       
    Bzip(const char *szFile, DFilesystem *DFSPtr) : DFile(szFile, DFSPtr)
    {
    }

    ~Bzip()
    {
    }

    // Compresses the file.  Returns a path to the compressed file.
    wxString Create( wxProgressDialog* aProgressDialog );
    // Decompresses the file.  Returns a path to the decompressed file.
    wxString Extract( wxProgressDialog* aProgressDialog );
};

#endif