#if !defined ( DFILE_HPP )
#define DFILE_HPP

#include "dfilesystem.hpp"

// Wrapper for a file.
class DFile
{
public:
       
       
    DFile(const char *szFile = 0, DFilesystem *DFSPtr = 0)
    {
        if(szFile == 0)
        {
            mFilePath = GetTempName();
        }
        else
        {
            mFilePath = szFile;
        }
        
        
        bNewDFS = false;
        
        if(DFSPtr = 0)
        {
            this->DFSPtr = DFSPtr;
        }
        else
        {
            this->DFSPtr = new DFilesystem;
            bNewDFS = true;
        }
            
    }  

    
    virtual ~DFile()
    {
        if(bNewDFS)
        {
            delete DFSPtr;
        }
    }   



    wxString GetTempName();
    

    inline void MoveFile(const char *szSrc, const char *szDest) const
    {    
        DFSPtr->MoveFile(szSrc, szDest);
    }
    
    
protected:
        
    DFilesystem *DFSPtr;
    wxString mFilePath;
    
private:
        
    bool bNewDFS;
};
#endif