#if !defined ( DFDIZWINDOW_HPP )
#define DFDIZWINDOW_HPP
// ID ENUM
// Wx Reserved identifiers are in the rage 4999 - 5999.
enum
{
    ID_CREATE = 5
};


// Main Frame Class, no arguments.
class DFDIZWindow : public wxFrame
{
public:
       
    DFDIZWindow(const wxString &wxsTitle, const wxPoint &wxpPos, const wxSize &wxsSize,
        DFArcFrame *DFMainPtr) : wxFrame(0, -1, wxsTitle, wxpPos, wxsSize,
        wxDEFAULT_FRAME_STYLE), DFMainPtr(DFMainPtr)
    {
        PrepareGUI();
    }
    
    ~DFDIZWindow()
    {
    }
    
    
    void PrepareGUI();
       
    void OnQuit(wxCloseEvent &Event);
    void Quit(wxCommandEvent &Event);
    void CreateDIZFile(wxCommandEvent &Event);

private:
        
    DECLARE_EVENT_TABLE()
    
    DFArcFrame *DFMainPtr;
    
    wxComboBox *DirList;
    wxTextCtrl *DModTitle;
    wxTextCtrl *DIZDescription;
};
#endif